/*****************************************************************************
 * bf609_w25q32bv_dpia.c
 *****************************************************************************/

#include <sys/platform.h>

#include "common/flash.h"
#include "common/spi.h"

const char *pEzKitTitle = "UCB-BF706";

extern const struct spi_ctlr adi_spi_bf70x_ctlr;
extern struct flash_info n25q064a13e_info;

void dpia_init(void)
{
	*pREG_L1IM_ICTL = 0;
	*pREG_L1DM_DCTL = 0;

	/* Reset SCI */
    *pREG_SEC0_CCTL0 |= ENUM_SEC_CCTL_RESET;
	/* Clear NMI */
	*pREG_SEC0_CSTAT0 |= ENUM_SEC_CSTAT_NMI;
	/* Reset SEC */
    *pREG_SEC0_GCTL = ENUM_SEC_GCTL_RESET;

	spi_ctlr = &adi_spi_bf70x_ctlr;
	flash_info = &n25q064a13e_info;

	/* disable DMA7 which might be running and will trigger
	   Rx interrupt handler as soon as we install it.  */
	*pREG_DMA7_CFG = 0;

	/* We use GPIO PD11 as SPI flash /CS.
	   Clear FER bit since the boot code will set it on boot mode 3.  */
	*pREG_PORTB_FER_CLR = BITM_PORT_DATA_PX15;
	*pREG_PORTB_DIR_SET = BITM_PORT_DATA_PX15;

	*pREG_PORTB_FER_SET = BITM_PORT_FER_SET_PX12 | BITM_PORT_FER_SET_PX11 | BITM_PORT_FER_SET_PX10;
	*pREG_PORTB_MUX &= ~(BITM_PORT_MUX_MUX12 | BITM_PORT_MUX_MUX11 | BITM_PORT_MUX_MUX10);
}

#include "common/dpia.c"
